image: registry.gitlab.com/etherlab.org/build-container-factory/leap-15.3:qt5

coverage:
  variables:
    # Workaround for MessageModel tests
    TZ: CET
    PDCOM_MAJOR_VERSIONS: 5
    CXXFLAGS: "--coverage -fsanitize=address -fsanitize=undefined -D_PDSERV_CUSTOM_GCOV_HOOK -Wall -Wextra -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC"
    CFLAGS: "--coverage -fsanitize=address -fsanitize=undefined -D_PDSERV_CUSTOM_GCOV_HOOK -Wall -Wextra -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC"
    LDFLAGS: "--coverage -fsanitize=address -fsanitize=undefined"
    NOSE2_LD_PRELOAD: "/usr/lib64/libasan.so.4"
    WORKSPACE: /tmp/pdcom_integration_tests
  stage: build
  script:
    - LSAN_OPTIONS=suppressions=$(pwd)/suppress_leaks.txt ./build_and_run.sh
    - |
      pushd $WORKSPACE; gcovr --xml-pretty -o $CI_PROJECT_DIR/build/coverage.xml \
      --exclude src/qtpdcom/build --exclude src/qtpdcom/test \
      --exclude src/pdcom5/build --exclude src/pdserv/build --exclude src/pdcom5/test --exclude src/pdserv/test \
      --exclude src/pdserv/example --exclude src/pdcom5/example --exclude-unreachable-branches \
      --print-summary --root src src/*/build $CI_PROJECT_DIR/build
    - mkdir -p $CI_PROJECT_DIR/html
    - |
      pushd $WORKSPACE; gcovr --html --html-details -o $CI_PROJECT_DIR/html/index.html \
      --exclude src/qtpdcom/build --exclude src/qtpdcom/test \
      --exclude src/pdcom5/build --exclude src/pdserv/build --exclude src/pdcom5/test --exclude src/pdserv/test \
      --exclude src/pdserv/example --exclude src/pdcom5/example --exclude-unreachable-branches \
      --root src src/*/build $CI_PROJECT_DIR/build
  coverage: /^\s*lines:\s*\d+.\d+\%/
  artifacts:
    when: always
    reports:
      coverage_report:
        path: build/coverage.xml
        coverage_format: cobertura
      junit:
        - build/src/pdcom5/qtpdcom1.xml
        - build/src/pdcom5/pdcom5_cpp.xml
        - build/src/pdcom5/pdcom5_py.xml
        - build/src/pdcom5/pdserv_1_1_0.xml
    paths:
      - build/Testing/Temporary/LastTest.log
      - html

update docs server:
    stage: deploy
    rules:
      - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == "etherlab.org"
    trigger: etherlab.org/docs


format:
    image: registry.gitlab.com/etherlab.org/build-container-factory/leap-15.3:base
    stage: build
    script:
        - pre-commit install
        - pre-commit run --all-files

include:
    - template: 'Workflows/MergeRequest-Pipelines.gitlab-ci.yml'
